/**********************************************************************
   Copyright [2012] [KibaCorp]

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/
//********************************************************************


/*

** UART3 RS232 asynchronous communication demonstration code
** modified 5/31/2011 for N+V
**modified for U1B TX/RX 
U1BTX  BOT pin 7 PIC32 pin 49
U1BRX BOT pin 5 PIC32 pin 43
*/


//
#include "UART3.H"


//
// timing and baud rate calculations
#define BRATE    (FPB/4/9600)-1   // 9600 baud 
#define U_ENABLE 0x8008	            // enable UART (BREGH=1)
#define U_TX     0x1400	            // enable transmission

//modify to U1
// initialize the UART3 serial port
void initU3( void)
{
    U1BBRG 	= BRATE;    
    U1BMODE 	= U_ENABLE;
    U1BSTA 	= U_TX;
  //  TRTS    = 0;        // make RTS output
 //   RTS     = 1;        // set RTS default status
} // initU2


// send a character to the UART3 serial port
int putU3( int c)
{
   // while ( CTS);		        // wait for !CTS, clear to send
    while ( U1BSTAbits.UTXBF);   // wait while Tx buffer full
    U1BTXREG = c;
    return c;
} // putU2


// wait for a new character to arrive to the UART2 serial port ( non interrupt)
char getU3( void)
{
  //  RTS = 0;            // assert Request To Send !RTS
    while ( !U1BSTAbits.URXDA);	// wait for a new character to arrive
  //  RTS = 1;
    return U1BRXREG;		// read the character from the receive buffer
}// getU2

// send a null terminated string to the UART2 serial port
int puts( const char *s)
{
	while( *s)			// loop until *s == '\0' end of string
		putU3( *s++);	// send char and point to the next one
    putU3( '\r');       // terminate with a cr / line feed
} // putsU2

