/**********************************************************************
   Copyright [2012] [KibaCorp]

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/
//********************************************************************


#ifndef __UARTDRV_H__
#define __UARTDRV_H__ 
//modified for robot UART1B 9/25/2011

#define FCY     10000000L
#define FPB     10000000L   
#include <plib.h>


void resetXbee(void); //reset xbee
// initialize the UART1B serial port

void initU3( void);
// send a character to the UART1B serial port

int putU3( int c);

// wait for a new character to arrive to the UART1B serial port
char getU3( void);
// send a null terminated string to the UART1B serial port
//examples
//puts( "Exploring the PIC32!");
//    sprintf( s, "Exploring the PIC32! %d", 17);

int puts( const char *s);

// useful macros
#define clrscr() puts( "\x1b[2J") 
#define home()   puts( "\x1b[1,1H")
#endif








