/**********************************************************************
   Copyright [2012] [KibaCorp]

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/
//********************************************************************


#ifndef __SYS_H__
#define __SYS_H__ 

////system sets up for robot operations 8/7/11
////20MZ system clock and 10 MHZ perpherial clock
//#pragma config FNOSC = PRIPLL, POSCMOD = HS, FPLLIDIV = DIV_2, FPLLMUL = MUL_20, FPBDIV = DIV_1, FPLLODIV = DIV_8
//#pragma config FWDTEN = OFF


//system clock should be 20Mhz  8/2*20 = 80 80/8 =10 System CLK    20/1 =10 MHZ Perpherial CLock
//20 msec = 200000 or 0x030d40
//1.5 msec 15000 0x3A98    center
//1.3 msec 13000 0x32C8    fastest CW
//1.7 msec 17000 0x4268    fastest CCW
//servo speed settings

#define Full_CW  0x32C8    //fastest CW
#define Half_CW  0x32C8/2    //half speed CW
#define Qtr_CW  0x32C8/4    //quarter speed CW
#define Eight_CW 0x32C8/8    //eight speed CW

#define Full_CCW  0x4268    //fastest CCW
#define Half_CCW  0x4268/2    //half CCW
#define Qtr_CCW  0x4268/4    //quarter CCW
#define Eight_CCW 0x4268/8    //eight speed CW

#define StopR	 0x3A98 	//center postion of right servo -no rotation
#define StopL	 0x3A98 	//center postion of left servo -no rotation

//slow angle turns (tick timer settings)--all speed 1/4 
// *** need measurement
#define zero_degree  0
#define ninety_degree 0
#define one_eighty_degree 0
#define two_seventy_degree 0
#define three_sixty_degree 0
/* servo ICD
****************************************************************************
				Left Servo		Right Servo		Angle (time)

Left Turn		Qtr_CCW				STOP			0-360			 			

Right Turn		STOP				Qtr_CW			0-360

Forward			CCW					CW

Backward		CW					CCW

Stop			STOP				STOP
*************************************************************************
*/
#endif




