/**********************************************************************
   Copyright [2012] [KibaCorp]

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/
//********************************************************************


#include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
 #include "xbee.h"
 #include "UART3.h"
 #include "timer.h"
  #include "Graphics.h"
extern volatile int TimeOut;
// * adapted from Make Controller source code for PIC32 and MPLAB and C32 compiler.
//Code Lisence is really only relevant if you're planning on publicly releasing or selling code/programs that you create with the Make Controller
//  * this code is not used for Make Controller and therefore is free of liscense issues
//thk 7/8/2012 added XBEE_WRITE, XBEE_SENDPACKET, XBEE_CREATETX16PACKET
//thk 7/13/2012 add reset packet and UART and XBEE_READ
//thk 7/15/2012 added Xbee read, getpacket, get readable
//thk 7/23/2012 added XBee_IntToBigEndianArray, XBee_GetIOValues,XBee_ReadIO16Packet
//thk 7/23/2012 XBee_CreateATCommandPacket,XBee_ReadAtResponsePacket
/*thk 7/24/2012 added mods to XBee for XBee.h for
struct definition for XBee_RATCommand
 XBee XBeeApiId
 
   XBEE_RATCOMMAND = 0x17,			
   XBEE_RATCOMAANDRESPONSE = 0x97,
thk 7/24/2012 made changes to XBee_SendPacket, need to develop a create RAT packet function
thk 7/24/2012 created 
 bool XBee_CreateRATCommandPacket( XBeePacket* xbp, uint8 frameID, uint16 dest, uint8 options, char* cmd, uint8* params, uint8 datalength )
 thk 7/26/2012 modified sendpacket for simulation
 thk 8/4/2012 restored sendpacket for debug
*/
extern volatile unsigned char qin;  //index for queue in
extern volatile unsigned char qout; //index for queuse out
extern unsigned char s[];
volatile char rxchar;
volatile unsigned char rxflag;
  XBeePacket MtxPacket;	//transmit packet
  XBeePacket myPacket; //receive packet
 char buff [12];  //graphics display buffer
unsigned char outBuf[100];
unsigned char *o; // = &outBuf[0];
#define BUF_SIZE 100  //also defiend in main for uartrx interrupt
 //my debug routine --channels I/O to outbuffer for examine rather the 
 //init pointers and buffer
 void initoutBuf (void) {
	 int v =0;
	 for (v=0; v< sizeof outBuf; v++) {
		 
	 outBuf[v] =0x00;
	 }
	  o =  &outBuf[0];
	 
	 
	 
	} 
	//send char to outBuf
 void SetChar ( unsigned char x) {
	  *o++ =x;
	 	 	} 
/** 
   Initialize a packet before reading into it.

 XBee_GetPacket( )
00338 */
 void XBee_ResetPacket( XBeePacket* packet )
 {
   packet->dataPtr = (uint8*)packet;
   packet->crc = 0;
   packet->rxState = XBEE_PACKET_RX_START;
   packet->length = 0;
   packet->index = 0;
   packet->apiId = 0;
   memset( packet->payload, 0, 100 );
 }

bool XBee_ReadRatResponsePacket( XBeePacket* xbp, uint8* frameID,uint16* srcAddress, char* cmd, uint8* status, int* datavalue )
 { 
   if( xbp->apiId !=  XBEE_RATCOMMANDRESPONSE )
     return false;
   if( frameID )
     *frameID = xbp->ratResponse.frameID;
    if( srcAddress )
   {
     *srcAddress = xbp->ratResponse.source[0];
     *srcAddress <<= 8;
     *srcAddress += xbp->ratResponse.source[1];
        }
   
     if( cmd ) //could not get this to work went right to s queue
   { 
    *cmd++ = s[15];
    *cmd =s[16];
   }
  
   if( status )
     *status = xbp->ratResponse.status;
   if( datavalue )
   {
     uint8 *dataPtr = xbp->ratResponse.value;
     int i;
     int datalength = xbp->length - (5+8+2); // data comes after apiID, frameID, 2-bytes of cmd, and 1-byte status
     *datavalue = 0;
     for( i = 0; i < datalength; i++ )
    {
       *datavalue <<= 8;
       *datavalue += *dataPtr++;
     }
   }
   return true;
 }
 bool XBee_ReadAtResponsePacket( XBeePacket* xbp, uint8* frameID, char* cmd, uint8* status, int* datavalue )
 { 
   if( xbp->apiId != XBEE_ATCOMMANDRESPONSE )
     return false;
   if( frameID )
     *frameID = xbp->atResponse.frameID;
     if( cmd ) //could not get this to work went right to s queue
   { 
    *cmd++ = s[5];
    *cmd =s[6];
   }
  
   if( status )
     *status = xbp->atResponse.status;
   if( datavalue )
   {
     uint8 *dataPtr = xbp->atResponse.value;
     int i;
     int datalength = xbp->length - 5; // data comes after apiID, frameID, 2-bytes of cmd, and 1-byte status
     *datavalue = 0;
     for( i = 0; i < datalength; i++ )
    {
       *datavalue <<= 8;
       *datavalue += *dataPtr++;
     }
   }
   return true;
 }

 void XBee_CreateATCommandPacket( XBeePacket* packet, uint8 frameID, char* cmd, uint8* params, uint8 datalength )
 {
   packet->apiId = XBEE_ATCOMMAND;
   packet->atCommand.frameID = frameID;
   uint8* p = packet->atCommand.command;
   *p++ = *cmd++;
   *p++ = *cmd;
   p = packet->atCommand.parameters;
   while( datalength-- )
     *p++ = *params++;
      }

 int XBee_Write( uchar *buffer, int count )
 {
	 int v=0;
  // return Serial_Write( SERIAL_0, buffer, count );
		for (v=0; v< count; v++) {
		 
	 	//SetChar	(buffer[v]) ;
	 	putU3((int)buffer[v]);
	 }
	
 }
 /** 
   Returns the number of bytes in the queue 
   */
 int XBee_GetReadable( void ) {
	 int count =0;
	 if (qin==qout) return 0;
	 if (qin>qout) return (qin-qout);
	 if (qout>qin) return (qout-qin);
	 qin =0;
	 qout =0;
	 return 0;
 
	}
/* reads UART1B from incoming queue and retruns it.reset rxflag use XBee_GetReadable to determine #bytes
use in direct API mode
*/
unsigned char XBee_Read(void )
 {
	 unsigned char temp =0;
	 rxflag =0;
	 temp = s[qout];
	 qout++;
	 if (qout> BUF_SIZE) qout =0;
	 
   return temp;
 }

 static bool XBee_GetIOValues( XBeePacket* packet, int *inputs )
 {
   if( packet->apiId == XBEE_IO16 || packet->apiId == XBEE_IO64 )
   {
     int i;
     static bool enabled;
     int digitalins = 0;
     uint8* p;
     int channelIndicators;
     if( packet->apiId == XBEE_IO16 )
     {
       p = packet->io16.data;
       channelIndicators = (packet->io16.channelIndicators[0] << 0x08) | packet->io16.channelIndicators[1];
     }
     else // packet->apiId == XBEE_IO64
     {
       p = packet->io64.data;
       channelIndicators = (packet->io64.channelIndicators[0] << 0x08) | packet->io64.channelIndicators[1];
     }
 
     for( i = 0; i < XBEE_INPUTS; i++ ) //15  counts analog and digital ins separately
     {
       enabled = channelIndicators & 1;
       channelIndicators >>= 1;
       if( i < 9 ) // digital ins
       {
         inputs[i] = 0; // zero out the 9 inputs beforehand
         if( enabled )
         {
           if( !digitalins )
           {             int dig0 = *p++ << 0x08;
             digitalins = dig0 | *p++;
           }
           inputs[i] = ((digitalins >> i) & 1) * 0xffff;
         }
       }
       else // analog ins
       {
         if( enabled )
         {
           int ain_msb = *p++ << 0x08;
           inputs[i-9] = ain_msb | *p++;
         }
       }
     }
     return true;
   }
   else
     return false;
 }

 bool XBee_ReadIO16Packet( XBeePacket* xbp, uint16* srcAddress, uint8* sigstrength, uint8* options, int* samples )
 {
   if( xbp->apiId != XBEE_IO16 )
     return false;
   if( srcAddress )
   {
     *srcAddress = xbp->io16.source[0];
     *srcAddress <<= 8;
     *srcAddress += xbp->io16.source[1];
        }
   if( sigstrength )
    *sigstrength = xbp->io16.rssi;
  if( options )
     *options = xbp->io16.options;
   if( samples )
   {
     if( !XBee_GetIOValues( xbp, samples ) )
      return false;
  }
   return true;
 } 


 void XBee_IntToBigEndianArray( int value, uint8* array )
 {
   array[0] = (value >> 24) & 0xFF;
   array[1] = (value >> 16) & 0xFF;
   array[2] = (value >> 8) & 0xFF;
   array[3] = value & 0xFF;
 }		
 
 
 int XBee_SendPacket( XBeePacket* packet, int datalength )
 {
  
   //   SetChar(  XBEE_PACKET_STARTBYTE );
  	putU3   (  XBEE_PACKET_STARTBYTE );
   int size = datalength;
   switch( packet->apiId )
   {
     case XBEE_TX64: //account for apiId, frameId, 8 bytes destination, and options
       size += 11;
       break;
     case XBEE_TX16: //account for apiId, frameId, 2 bytes destination, and options
       size += 5; 
   
       break;
     case XBEE_ATCOMMAND: // length = API ID + Frame ID, + AT Command (+ Parameter Value)
       size = (datalength > 0) ? 8 : 4; // if we're writing, there are 4 bytes of data, otherwise, just the length above
       break;
     case XBEE_RATCOMMAND: // *** lenghth =API ID+Frame ID +Destination 64 ADDR+ Destin 16 bit ADDR+ option+ AT Commnad (+Paramter value)
     size = (datalength >0) ? 19:15;  // if we're writing, there are 4 bytes of data, otherwise, just the length above
    break;
     default:
       size = 0;
       break;
          }
 
 //  SetChar(  (size >> 8) & 0xFF ); // send the most significant bit
 //  SetChar( size & 0xFF ); // then the LSB
    putU3(  (size >> 8) & 0xFF ); // send the most significant bit
  	putU3( size & 0xFF ); // then the LSB
   packet->crc = 0; // just in case it hasn't been initialized.
   uint8* p = (uint8*)packet;
   while( size-- )
   {
  //   SetChar(  *p );
     	putU3(  *p );
     packet->crc += *p++;
        }
   //uint8 test = 0xFF - packet->crc;
  // SetChar(  0xFF - packet->crc );
   	putU3(  0xFF - packet->crc );
   return CONTROLLER_OK;
 }
 
 
 bool XBee_CreateTX16Packet( XBeePacket* xbp, uint8 frameID, uint16 destination, uint8 options, uint8* data, uint8 datalength )
 {
   xbp->apiId = XBEE_TX16;
   xbp->tx16.frameID = frameID;
   xbp->tx16.destination[0] = destination >> 8;
   xbp->tx16.destination[1] = destination & 0xFF;
   xbp->tx16.options = options;
   xbp->length = datalength + 5;
   uint8* p = xbp->tx16.data;
   while( datalength-- )
     *p++ = *data++;
   return true;
 }
 
  bool XBee_CreateRATCommandPacket( XBeePacket* xbp, uint8 frameID, uint16 dest, uint8 options, char* cmd, uint8* params, uint8 datalength )
 {
   xbp->apiId = XBEE_RATCOMMAND;
   xbp->ratCommand.frameID = frameID;
 //zero out 64 bit address only use 16 bit
	 xbp->ratCommand.destination[0] = 0;
	 xbp->ratCommand.destination[1] = 0;
	 xbp->ratCommand.destination[2] = 0;
	 xbp->ratCommand.destination[3] = 0;
	 xbp->ratCommand.destination[4] = 0;
	 xbp->ratCommand.destination[5] = 0;
	 xbp->ratCommand.destination[6] = 0;
	 xbp->ratCommand.destination[7] = 0;
	 //local address
   xbp->ratCommand.dest[0] = dest >> 8;
   xbp->ratCommand.dest[1] = dest & 0xFF;
   //options
   xbp->ratCommand.options = options;
    uint8* p = xbp->ratCommand.command;
   *p++ = *cmd++;
   *p++ = *cmd;
   p = xbp->ratCommand.parameters;
   while( datalength-- )
     *p++ = *params++;
      }

 
int XBee_GetPacket( XBeePacket* packet, int timeout )
 {
   timeout_set(timeout*MILLISEC);
 
   do
   {
     
     while(XBee_GetReadable() )
     {
       int newChar =(int) XBee_Read();
       
   
       switch( packet->rxState )
       {
         case XBEE_PACKET_RX_START:
           if( newChar == XBEE_PACKET_STARTBYTE )
             packet->rxState = XBEE_PACKET_RX_LENGTH_1;
           break;
         case XBEE_PACKET_RX_LENGTH_1:
           packet->length = newChar;
           packet->length <<= 8;
           packet->rxState = XBEE_PACKET_RX_LENGTH_2;
           break;
         case XBEE_PACKET_RX_LENGTH_2:
           packet->length += newChar;
           if( packet->length > XBEE_MAX_PACKET_SIZE ) // in case we somehow get some garbage
            packet->rxState = XBEE_PACKET_RX_START;
           else
             packet->rxState = XBEE_PACKET_RX_PAYLOAD;
           packet->crc = 0;
           break;
         case XBEE_PACKET_RX_PAYLOAD:
           *packet->dataPtr++ = newChar;
           if( ++packet->index >= packet->length )
             packet->rxState = XBEE_PACKET_RX_CRC;
           packet->crc += newChar;
           break;
         case XBEE_PACKET_RX_CRC:
           packet->crc += newChar;
           packet->rxState = XBEE_PACKET_RX_START;
           if( packet->crc == 0xFF )
             return 1;
           else
           {
             XBee_ResetPacket( packet );
             return 0;
           }
       }
     }
    
   } while( !TimeOut );
   return 0;
 } 
 
bool XBee_ReadTXStatusPacket( XBeePacket* xbp, uint8* frameID, uint8* status )
 {
   if( xbp->apiId != XBEE_TXSTATUS )
     return false;
   if( frameID )
     *frameID = xbp->txStatus.frameID;
   if( status )
     *status = xbp->txStatus.status;
   return true;
 }
 bool XBee_ReadRX16Packet( XBeePacket* xbp, uint16* srcAddress, uint8* sigstrength, uint8* options, uint8** data, uint8* datalength )
 {
   if( xbp->apiId != XBEE_RX16 )
     return false;
 
   if( srcAddress )
   {
     *srcAddress = xbp->rx16.source[0];
     *srcAddress <<= 8;
     *srcAddress += xbp->rx16.source[1];
      }
  if( sigstrength )
     *sigstrength = xbp->rx16.rssi;
  if( options )
     *options = xbp->rx16.options;
   if( data )
     *data = xbp->rx16.data;
   if( datalength )
     *datalength = xbp->length - 5;
   return true;
 }
 
 int Send_RAT ( int cmdparameters, char* cmd, uint16 addr,uint8 option, uint8 datalength ){
	   uint8 params[4];
   XBee_IntToBigEndianArray(cmdparameters , params );
  //  XBeePacket MtxPacket;
   // bool XBee_CreateRATCommandPacket( XBeePacket* xbp, uint8 frameID, uint16 dest, uint8 options, char* cmd, uint8* params, uint8 datalength )
   //  XBee_CreateRATCommandPacket( &MtxPacket, 0x31,0x3435,2, "IR", &params, 4 ); 
    XBee_CreateRATCommandPacket(&MtxPacket,0x31, addr,option, cmd, &params[0], datalength );
     XBee_SendPacket( &MtxPacket, 4 );
     qin =0; //flush queue to align for incoming response
	qout=0;
     //add capability to track response and modify return
     return 1;
 }
 int Send_LAT ( int cmdparameters, char* cmd,uint8 datalength ){
	   uint8 params[4];
   XBee_IntToBigEndianArray(cmdparameters , params );
 //   XBeePacket MtxPacket;
    //void XBee_CreateATCommandPacket( XBeePacket* packet, uint8 frameID, char* cmd, uint8* params, uint8 datalength )
  XBee_CreateATCommandPacket(&MtxPacket ,0x31, cmd, &params[0], datalength ) ; 
   XBee_SendPacket( &MtxPacket, 4 );
     qin =0; //flush queue to align for incoming response
	qout=0;
     //add capability to track response and modify return
     return 1;
 }
 int recv_packets (void) {
	 qin =0; //flush queue to align for incoming response
	qout=0;
	clearScreen();  
	 XBee_ResetPacket( &myPacket );
    if (XBee_GetPacket( &myPacket, 100 ) )
     {
	     
	  uint8 frameID;
     char command[2];
     uint16 src;
     uint8 status;
     int value = -1;
      if( XBee_ReadRatResponsePacket( &myPacket, &frameID, &src, &command[0], &status, &value ) )
    { //had to make changes here
       	AT( 0, 0) ; 
	   putsV("RAT Response");
	   AT(0,1);
	     sprintf(buff, "src= %d",src); //source
	 	putsV(&buff[0]);
	  	AT(0,2);
	 sprintf(buff, "command= %c%c",command[0], command[1]); //source
	 	putsV(&buff[0]);
	 
	 	AT(0,3);
  
	    switch (status) {
	   			case 0: 
	   			putsV(" ok");
	   			break;
	   			case 1:
	   			putsV(" error");
	   			break;
	   			case 2:
	   			putsV("invalid cmd");
	   			break;  
	   			case 3:
	   			putsV("invalid pram");
	   			break;  
	   			default:
	   			putsV("UKN");
	   			break;  
	   			  
	   			 } 
			
 

	     dumpVmap();	
	     qin=0;
	     qout=0;
       return 1;
   }
     if( XBee_ReadAtResponsePacket( &myPacket, &frameID, &command[0], &status, &value ) )
    { //had to make changes here
       	AT( 0, 0) ; 
	   putsV("LAT Response");
	   AT(0,1);
	  // sprintf(buff, "FrameID= %d",frameID); //source
	 //	putsV(&buff[0]);
	 	AT(0,1);
	 sprintf(buff, "command= %c%c",command[0], command[1]); //source
	 	putsV(&buff[0]);
	 	AT(0,2);
  
	    switch (status) {
	   			case 0: 
	   			putsV(" ok");
	   			break;
	   			case 1:
	   			putsV(" error");
	   			break;
	   			case 2:
	   			putsV("invalid cmd");
	   			break;  
	   			case 3:
	   			putsV("invalid pram");
	   			break;  
	   			default:
	   			putsV("UKN");
	   			break;  
	   			  
	   			 } 
			
 

	     dumpVmap();	
	     qin=0;
	     qout=0;
       return 1;
    }
	   //  uint16 src;
     uint8 sigstrength;
     int samples[9];
     if( XBee_ReadIO16Packet( &myPacket, &src, &sigstrength, NULL, samples ) )
    {
	    	AT( 0, 0) ; 
	   putsV("16IO packet");
	    sprintf(buff, "src= %d",src); //source
	     AT (0,1); 
	 	putsV(&buff[0]);
	 	AT (0,2)
	 sprintf(buff, "rssi= %d ",sigstrength);  //signal strength
 	putsV(&buff[0]);
		AT(0,3); 
		sprintf(buff,"ana#0 =%d",samples[0]);
				putsV(&buff[0]);
				AT(0,4);
	sprintf(buff,"ana#3 =%d",samples[2]);
			putsV(&buff[0]);
			AT(0,5);
	sprintf(buff,"dig#1 =%d",samples[1]);
				putsV(&buff[0]);
				AT(0,6);
	sprintf(buff,"dig#2 =%d",samples[3]);
	putsV(&buff[0]);
				
	  dumpVmap();
	   qin=0;
	     qout=0;
       return 1;		
	    
	   } 
 
// uint16 src;
//     uint8 sigstrength;
     uint8* data;
     uint8 datalength;
     int i =0;
     if( XBee_ReadRX16Packet( &myPacket, &src, &sigstrength, NULL, &data, &datalength ) )
     {
	   	AT( 0, 0) ; 
	   putsV("16bit packet");
	   AT (0,1);  
	 sprintf(buff, "src= %d",src); //source
	 	putsV(&buff[0]);
		AT (0,2)
 	 sprintf(buff, "rssi= %d ",sigstrength);  //signal strength
  	putsV(&buff[0]);
	
		AT(0,3); 
			putsV(" Data");
		AT(0,4);
		int temp;
		 for (i =0;i<datalength;i++)
		 {
		 temp =*data++;
			putcV(temp);
			dumpVmap();
	   qin=0;
	     qout=0;
       return 1;	 
			} 
	  
   	  
	     
     
     
     }
      XBee_ResetPacket( &myPacket ); // then clear it out before reading again
     Delayms(10); 
     return (0);  
		

 
	 
	 
	 
	 
	} 
	}   