/**********************************************************************
   Copyright [2012] [KibaCorp]

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/
//********************************************************************


/*********************************************************************
 *
 *                 EXP32 XBEE programming Code
 *
 *********************************************************************
 
 thk derived code was robot code version 11
 thk timinig trimed to 20MZ system clock and 10 MHZ perpherial clock
 beginning robot coding--modified for XBEE api 7/4/12
 thk modifed MakeController Xbee library in non-violation of lisence since
 this code is not used in any MakeControoler design
 *********************************************************************
 
 *
 thk added pragma mod for 20Mhz clock and 10 Mhz perpherial clock
 thk added motor.c and system.h  8/7/2011
 thk added behavior.c  8/8/11
 thk added switches/leds and bumper I/O and timer.c 8/9/2011
 thk added arbitor and aviod 8/10/2011
 thk added adc for analog sensors using PIC24H book code modified
 thk added open drain for left/Right servos RD3/RD2 pins 2 and 1 of JP2
 thk tested 	forward(); backward();spinL();spinR(); idle(); 9/9/11
 thk added timer1 int for ADC of sensors
 thk removed CN and added debounce using Timer1 and added led to show bumper 9/10/11
 thk ver7 got home behavior functional 9/17/11
 thk ver8 added led states and clean up flow and interaction between behaviors
 thk ver9 ver8 behaviors not functioning --adding graphic 9/24/11 to monitor
 thk ver9 added uart3 9/24/11 with interrupt 9/25/11
 thk 9/30/11 added string formatting
 thk 10/2/11 added buzzer digital on/off radio shack buzzer
 thk 10/3/2011 added CCW and CW rotatE
 thk begin XBEE API from paired down robot code ver 11 7/5/2012
 thk 7/4/2012 added Timeout using timer45,
 adeed XBEE_WRITE, XBEE_SENDPACKET, XBEE_RESETPACKET, XBEE_CREATEPACKET
 thk 7/15/12use of  Rb13 button for use by XBEE as /RESET
 thk 7/15/12 added convertHex and APImode and flushQueue
 thk 7/15/12 added full xbee read/write, create TXpacket, send packet and read packet
 thk 7/20/12 added XBee_ReadTXStatusPacket,XBee_ReadRX16Packet
 thk 7/21/2012 added XBee_IntToBigEndianArray, XBee_GetIOValues,XBee_ReadIO16Packet
 thk 7/21/2012 XBee_CreateATCommandPacket,XBee_ReadAtResponsePacket
 thk 7/22/2012 testing AT command/response ok
 thk 7/24/2012 begin wroking Remote AT command unique add-on to existing XBEE
 thk added simulation of RAT
 thk 8/4/2012 remove simulation of RAT --added debug
 thk 8/14/2012 was  reduced API using VER7 now integrating that API into former VER8 (working)
 thk 8/14/2012 need to add RAT test in Main 
 thk 9/1/2012 added RAT test ok added LAT test ok
 thk 9/2/2012 cleaned up extraneous code -LAT response ok
 thk 9/2/2012 added RAT resposne RAT ok
 thk 9/3/2012 added 2nd XBEE my =2 created ver11 and demo1
 thk 9/3/2012 working sleeping sensor demo2 in ver 12 -have one sensor demo wroking in ver12
 thk 9/3/2012 fomrating sensor data in 16IOpacket using s[9] s[10] --not tested --test and next step is 2 sensors
 thk 9/3/2012 demo2 works need to add RTCC
 **********************************************************************/
#include <plib.h>
#include <stdlib.h>
#include "system.h"
#include "timer.h"
#include "UART3.h"
#include "Graphics.h"
#include "xbee.h"



////system sets up for robot operations 8/7/11
////10MZ system clock and 10 MHZ perpherial clock
#pragma config FNOSC = PRIPLL, POSCMOD = HS, FPLLIDIV = DIV_2, FPLLMUL = MUL_20, FPBDIV = DIV_1, FPLLODIV = DIV_8
#pragma config FWDTEN = OFF
// Let compile time pre-processor calculate the PR1 (period)
#define SYS_FREQ 			(10000000L)
#define PB_DIV         		1
#define PRESCALE       		256
#define TOGGLES_PER_SEC		20  //ev 100 msec because of GP2D120
#define T1_TICK       		(SYS_FREQ/PB_DIV/PRESCALE/TOGGLES_PER_SEC)

#define debounce 2		//debounce count for bumpers =2*100 msc or .2 second

//RXQUEUE
#define BUF_SIZE 50  //also defined in xbee for xbee read
volatile unsigned char s[BUF_SIZE];
volatile int TimeOut =0;
volatile unsigned char qin = 0;  //index for queue in
volatile unsigned char qout = 0; //index for queuse out
volatile char rxchar =0;
volatile unsigned char rxflag =0;
 
int raw_photo_left;
int raw_photo_right;
int raw_VBAT;
int raw_IR_left;
int raw_IR_right;
int photo_left;   //processed normalized photcell values
int photo_right;
int IR_left;	// processed IR values binary thresholded
int IR_Right;

int APImode =0;	//this determine mode type for display needs

volatile unsigned int LCount;
volatile unsigned int RCount;	
    //  configure the CN interrupt handler
   // RG9 CN11  is bumper L
   // RG7 CN9   is bumper R
unsigned char MSnibble;
unsigned char LSnibble;
void convertHex( unsigned char a) {
	
	LSnibble = a& 0x0f;
	if (LSnibble > 9) 
	{ 
		LSnibble = LSnibble-9+0x40;
	}

	
	else
	{ LSnibble = LSnibble+0x30;}
	MSnibble = a>>4;

		if (MSnibble > 9) 
	{ 
		MSnibble = MSnibble-9+0x40;
	}
	else
	{ MSnibble = MSnibble+0x30;}
	
	
	
}
void flushQueue( void) {
	qin =0;
	qout=0;
	
}

   
void __ISR(_UART_1B_VECTOR, ipl1) UART1BHandler(void)
{
	rxchar = U1BRXREG;	
	s[qin]=rxchar;
	qin++;
	if (qin==BUF_SIZE)
	{
		qin =0;	
	}	
 	IFS2bits.U1BRXIF =0;
 	rxflag =1;	
	
}	

//configure the Timer 1 interrupt handler

void __ISR(_TIMER_5_VECTOR, ipl2) Timer5Handler(void)
{
    // clear the interrupt flag
   
    ConfigIntTimer45(T45_INT_OFF );
      	CloseTimer45 ();
		mT5ClearIntFlag();
	TimeOut =1;
	
	
	

//led indicator to indicate state
}

int main(void)
{
		DDPCON=0x00;
		AD1PCFG = 0xFFFFFFFF;  //make every thing digital
	//	unsigned int temp;

//	mPORTDOpenDrainOpen(BIT_2 | BIT_3); //open drain RD2 RD3 R servo, L servo
			
	//setup leds and push button switches and bumpers
				//setup L1 and L2
			mPORTBClearBits(  BIT_12 | BIT_11 );
			mPORTBSetPinsDigitalOut( BIT_12 | BIT_11 );
			//setup S1 RB15/CN12	
			mPORTBSetPinsDigitalIn( BIT_15 );
			//setup S2 RD5/CN14
		
			mPORTDSetPinsDigitalIn( BIT_5 );
			/* setup bumpers 
			Left bumper	 pin 8 RG9 CN11 
			Right bumper pin 5 RG7 CN9
			*/
			mPORTGSetPinsDigitalIn( BIT_7 | BIT_9 );		
			/* enable pullups on change notice pins 12,14 for switches
			and pins 8 left bumper and 5 right bumper */
		
			ConfigCNPullups(CN14_PULLUP_ENABLE |CN12_PULLUP_ENABLE | CN9_PULLUP_ENABLE |CN11_PULLUP_ENABLE);
	//enable bumper interrupts
			//might have to check if switches are effected****** 8/9/11	
			

//***********************************************************************			

		char buf[50];
 
	 
			

	LCDInit() ; //use LCD test mode 8x12	
 greenLEDOFF();
redLEDOFF();
   
    //configure UART1B interrupt with a priority of 1
    IEC2bits.U1BRXIE =1;
    IFS2bits.U1BRXIF =0;
    IPC12bits.U1BIP =1;
    
    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    // STEP 5. enable multi-vector interrupts
    INTEnableSystemMultiVectoredInt();
    
 		
 
 	initU3();	//initializes UART1B
 
 	resetXbee(); //reset Xbee --can only be called after UART1B init

	 	
		
  	 	
 			clearScreen();
 
 			AT( 0, 0) ; 
   	putsV( "AT Mode");
   	sprintf( buf, "+++" ); // enter command mode
    XBee_Write(  (uchar*)buf, strlen(buf) );
    	Delayms(1200);
     sprintf( buf, "ATMY0,D75,API1,CN\r" ); // set my and D7 high and enter API mode and leave command mode
    XBee_Write( (uchar*)buf, strlen(buf) );
     Delayms(50);	
 
   	  dumpVmap();
	timeout_set (SECOND);
	 while( !TimeOut);
	 clearScreen();
	AT( 0, 0) ; 
 
	do {

		putcV( (int)XBee_Read()); //output char to screen	
		 dumpVmap();		
		
	} while (XBee_GetReadable()>0);
	timeout_set (.5*SECOND);
	 while( !TimeOut);

	 clearScreen();
		AT( 0, 0) ; 
   	putsV( "API Mode");
   	 dumpVmap();
	  Delayms(2000);
     XBeePacket txPacket;
    flushQueue();	
    
      clearScreen();
	XBeePacket MtxPacket;
   uint8 params[4];
  
  Delayms(2000);
 flushQueue(); 
 // int Send_LAT ( int cmdparameters, char* cmd,uint8 datalength )
 Send_LAT (4,"D7",4 );
  recv_packets ();
   Delayms(2000);
    Send_LAT (5,"D7",4 );
    recv_packets ();   
  Delayms(2000);
       Nop();
 


   Send_RAT (2,"D4", 0x0001,2 , 4 ); //my =1 D4 is ADC
  recv_packets ();
      Delayms(2000);
    Send_RAT (3,"D2", 0x0001,2 , 4 ); //my =1 D3 is digital in
  recv_packets ();
       Delayms(2000);
   Send_RAT (0x1f40,"IR", 0x0001,2 , 4 ); //my =1 IR 0xfa0 (8sec)
     recv_packets ();
      Delayms(2000);
   Send_RAT (1,"IT", 0x0001,2 , 4 );  //my =1 samples before TX
  recv_packets ();
       Delayms(2000);
    Send_RAT (0x190,"SP", 0x0001,2 , 4 );  //my =1 SLEEP period = 4 seconds
  recv_packets ();
       Delayms(2000);
    Send_RAT (4,"SM", 0x0001,2 , 4 );  //my =1 SLEEP mode = cyclic
     
  
      while (1) {
    if( recv_packets ()){
    	greenLEDON();
      Delayms(2000); 
				}
       greenLEDOFF();
             }   
 
  
     while(1);	

 	XBeePacket myPacket;
   XBee_ResetPacket( &myPacket );
   char buff [12];  //graphics display buffer
   while( 1 ) //keep receiving packets
   {
    if (XBee_GetPacket( &myPacket, 100 ) )
     {
	     
	  uint8 frameID;
     char command[2];
    
     uint8 status;
     int value = -1;
     if( XBee_ReadAtResponsePacket( &myPacket, &frameID, &command[0], &status, &value ) )
    { //had to make changes here
       	AT( 0, 0) ; 
	   putsV("AT Response");
	   AT(0,1);
	   sprintf(buff, "FrameID= %d",frameID); //source
	 	putsV(&buff[0]);
	 	AT(0,2);
	 sprintf(buff, "command= %c%c",command[0], command[1]); //source
	 	putsV(&buff[0]);
	 	AT(0,3);
  
	    switch (status) {
	   			case 0: 
	   			putsV(" ok");
	   			break;
	   			case 1:
	   			putsV(" error");
	   			break;
	   			case 2:
	   			putsV("invalid cmd");
	   			break;  
	   			case 3:
	   			putsV("invalid pram");
	   			break;  
	   			default:
	   			putsV("UKN");
	   			break;  
	   			  
	   			 } 
			
 

	     dumpVmap();	
       Nop();
    }
	     uint16 src;
     uint8 sigstrength;
     int samples[9];
     if( XBee_ReadIO16Packet( &myPacket, &src, &sigstrength, NULL, samples ) )
    {
	    	AT( 0, 0) ; 
	   putsV("16IO packet");
//	    sprintf(buff, "src= %d",src); //source
//	     AT (0,1); 
//	 	putsV(&buff[0]);
//	 	AT (0,2)
//	 sprintf(buff, "rssi= %d ",sigstrength);  //signal strength
// 	putsV(&buff[0]);
//		AT(0,3); 
//		sprintf(buff,"ana#0 =%d",samples[0]);
//				putsV(&buff[0]);
//				AT(0,4);
//	sprintf(buff,"ana#3 =%d",samples[2]);
//			putsV(&buff[0]);
//			AT(0,5);
//	sprintf(buff,"dig#1 =%d",samples[1]);
//				putsV(&buff[0]);
//				AT(0,6);
//	sprintf(buff,"dig#2 =%d",samples[3]);
//	putsV(&buff[0]);
				
	  dumpVmap();		
	    Nop();
	   } 
      
	  
   	  	Nop();
   	    flushQueue();
   	  Delayms(500);
      clearScreen();  
	     
     
      XBee_ResetPacket( &myPacket ); // then clear it out before reading again
     }
     Delayms(10); 
        }
		


	return (0);
}




